#ifndef _STJ_MACROS_H
#define _STJ_MACROS_H

#undef SAFE_DELETE
#define SAFE_DELETE(ptr) \
if (ptr) { delete ptr; ptr = NULL; }

#undef SAFE_VDELETE
#define SAFE_VDELETE(ptr) \
if (ptr) { delete[]ptr; ptr = NULL; }

#define CLAMP(x, min, max) ((x)<(min) ? (min) :((x)>(max) ? (max) : (x)))

#define STANDARD_RES 256

#define INVALID_POSTAG 9999


/****************data blob idx **********************/
#define HASH_DATA_SIZE 1	//layer output blob num: data

#define HASH_DATA_BLOB 0	
/***************************************************/

/********************structure blob idx*****************/
#define HASH_STRUCTURE_SIZE 11	//offset, postag, m_bar, r_bar, def_num, valid_pos

#define HASH_TABLE_BLOB 0
#define OFFSET_BLOB 1
#define POSTAG_BLOB 2
#define VOLUME_IDX_BLOB 3
#define M_BAR_BLOB 4
#define R_BAR_BLOB 5
#define DEFNUM_BLOB 6
#define DEFNUM_SUM_BLOB 7 // def_num_sum[i] = sum(defnum(0:i-1));
#define M_SUM_BLOB 8	// m_sum[i] = sum(m(0:i-1)), where m=m_bar*m_bar*m_bar
#define R_SUM_BLOB 9	// r_sum[i] = sum(r(0:i-1)), where r=r_bar*r_bar*r_bar
#define RESOLUTION_BLOB 10
/******************************************************/


/****Old version shape is: channel * spatial
Now to consistent with Caffe, to faciliate the computation of loss of segmentation, we add num 1, the shape is 1 * channel * spatial
***************************************/
#define ADD_NUM_2_SHAPE 1

#if ADD_NUM_2_SHAPE
/***********************the shape of data blob********************/
#define CHANNEL_AXIS 1
#define SPATIAL_AXIS 2
#else
#define CHANNEL_AXIS 0
#define SPATIAL_AXIS 1
#endif


#define DUMP_2_TXT 0

#define USE_EMPTY_VALID_REGION 0

#define RECORD_NEIGHBOR 0
#endif